package org.fg;

import org.fg.sORB.*;
import java.util.*;
import java.io.*;
import java.net.*;


import org.fg.j2sbridge.*;

public class TCPClientSample {
  

   
   static class ExampleThread extends Thread{
             
      public void run(){
          
          try{
             Socket sock=new Socket("localhost",1444);
             InputStream is=new BufferedInputStream(sock.getInputStream(),2000);
             OutputStream os=new BufferedOutputStream(sock.getOutputStream(),2000);
             Random r =new Random();
             byte[] feld=new byte[10000];
             int maxIters=100;
             for(int i=0;i<maxIters;i++){
                 Utility.debugmsg("writing i="+i);
                 for(int j=0;j<feld.length;j++){
                    if(i==maxIters-1 && j==0)feld[0]=77;
                    else feld[j]=(byte)r.nextInt();
                    os.write(feld[j]);
                 }
                 os.flush();
                 Utility.debugmsg("reading");
                 for(int j=0;j<feld.length;j++){
                    byte b=(byte)is.read();
                    if(b!=feld[j])throw new Error("mismatch");
                 }                 
             }

        }catch(Exception e){
            Utility.errmsg("caught exception in ExampleThread.run:"+e);
            e.printStackTrace();
        }
      }
   }
   
   
   public static void multiThreadedExample() throws Exception{
          //ExampleThread[] threads=new ExampleThread[20];
          ExampleThread[] threads=new ExampleThread[20];
          for(int i=0;i<threads.length;i++){
             threads[i]=new ExampleThread();
             threads[i].start();
          }
          //wait until all threads terminate
          for(int i=0;i<threads.length;i++){
             threads[i].join();
          }
   }

   public static void main(String[] argv){
       try{
          //simpleExample();                    
          //refCountExample();
          multiThreadedExample();                    
       }
       catch(Exception e){
          System.out.println("caught Exception:"+e);
          e.printStackTrace();
       }
   }
     
     
}